#include <stdio.h>
#include <windows.h>
#include <process.h>
#include <GL/glut.h>

#include "interfaceSimulator.h"
#include "simulator.h"
#include "robot.h"
#include "config.h"

//------------------------------Private attributes

static HANDLE hThreadSimulator;
static DWORD ThreadIdSimulator;

//------------------------------Private functions

static DWORD WINAPI simulatorThread(LPVOID iValue) {

	char **trickIt;
	trickIt = (char**)malloc(sizeof(char *));
	*(trickIt) = (char*)malloc(sizeof(char));
	//Start the simulator
	initSimulator(1, trickIt);

	/* This return is never executed */
	return 0;
}

//------------------------------Public functions

void initialize() {

	hThreadSimulator
			= (HANDLE)CreateThread(NULL,0,simulatorThread, NULL,0,&ThreadIdSimulator);

}

void go(const directiontype direction, const int speed) {
	if(initialized == NOT_INITIALIZED)
	{
		initialized = INITIALIZED;
		initialize();
	}
	
	setSpeed(speed);
	turn(direction);
}

void turn(const directiontype direction) {
	if(initialized == NOT_INITIALIZED)
	{
		initialized = INITIALIZED;
		initialize();
	}
	
	switch (direction) {
	case forward_direction:
		setWheels(FWD, FWD);
		break;
	case backward_direction:
		setWheels(REV, REV);
		break;
	case left_direction:
		setWheels(REV, FWD);
		break;
	case right_direction:
		setWheels(FWD, REV);
		break;
	case stop_direction:
		setWheels(STOP, STOP);
		break;
	case straight_direction:
		setWheels(FWD, FWD);
		break;
	case go_direction:
		setWheels(FWD, FWD);
		break;
	default:
		printf("Invalid direction\n");
		break;
	}
}

int touch1() {
	if(initialized == NOT_INITIALIZED)
	{
		initialized = INITIALIZED;
		initialize();
	}
	
	return getTouch1State();
}

int touch3() {
	if(initialized == NOT_INITIALIZED)
	{
		initialized = INITIALIZED;
		initialize();
	}
	
	return getTouch3State();
}

int light2() {
	if(initialized == NOT_INITIALIZED)
	{
		initialized = INITIALIZED;
		initialize();
	}
	
	return getLight2State();
}
