#include "interfaceSimulator.h"
#include "main.h"
#include "lib_SimuInterface.h"

//------------------------------Private constants

/* Directions for the robot with values corresponding to definitions in the java class*/
#define GO 0
#define FORWARD 1
#define BACKWARD 2
#define LEFT 3
#define RIGHT 4
#define STOP 5
#define STRAIGHT 6

//------------------------------Public functions
JNIEXPORT void JNICALL Java_lib_SimuInterface_goNative
(JNIEnv * env, jobject obj, jint direction, jint speed) {

	switch ((int) direction) {
		/*go*/
		case GO:
		go(go_direction, speed);
		break;
		/*forward*/
		case FORWARD:
		go(forward_direction, speed);
		break;
		/*backward*/
		case BACKWARD:
		go(backward_direction, speed);
		break;
		/*left*/
		case LEFT:
		go(left_direction, speed);
		break;
		/*right*/
		case RIGHT:
		go(right_direction, speed);
		break;
		/*stop*/
		case STOP:
		go(stop_direction, speed);
		break;
		/*straight*/
		case STRAIGHT:
		go(straight_direction, speed);
		break;
	}
}

JNIEXPORT void JNICALL Java_lib_SimuInterface_turnNative
(JNIEnv * env, jobject obj, jint direction) {
	switch (direction) {
		/*go*/
		case GO:
		turn(go_direction);
		break;
		/*forward*/
		case FORWARD:
		turn(forward_direction);
		break;
		/*backward*/
		case BACKWARD:
		turn(backward_direction);
		break;
		/*left*/
		case LEFT:
		turn(left_direction);
		break;
		/*right*/
		case RIGHT:
		turn(right_direction);
		break;
		/*stop*/
		case STOP:
		turn(stop_direction);
		break;
		/*straight*/
		case STRAIGHT:
		turn(straight_direction);
		break;
	}
}

JNIEXPORT jint JNICALL Java_lib_SimuInterface_light2Native
(JNIEnv * env, jobject obj) {
	return light2();
}

JNIEXPORT jboolean JNICALL Java_lib_SimuInterface_touch1Native
(JNIEnv * env, jobject obj) {
	return touch1();
}

JNIEXPORT jboolean JNICALL Java_lib_SimuInterface_touch3Native
(JNIEnv * env, jobject obj) {
	return touch3();
}
