#include <windows.h>

#include "robot.h"
#include "config.h"

//------------------------------Private attributes
//Robot position
static double robotX;
static double robotZ;
static double robotR;

//Sensors
static unsigned char touch1State;
static unsigned char touch3State;
static unsigned char light2State;

//Movement
static double moveWheelLeft;
static double moveWheelRight;
static int speed;

//------------------------------Public functions
void moveRobotTo(const double x, const double z, const double r) {
	robotX=x;
	robotZ=z;
	robotR=r;
}

void moveRobotToAdd(const double x, const double z, const double r) {
	/* Make it CPU perfs independant */
	Sleep(1);

	robotX+=x;
	robotZ+=z;
	robotR+=r;
	if (robotR>=360)
		robotR-=360;
	if (robotR<0)
		robotR=360+robotR;
}

void setWheels(const movement valueWheelLeft, const movement valueWheelRight) {
	switch (valueWheelLeft) {
	case FWD:
		moveWheelLeft=speed*STEP;
		break;
	case REV:
		moveWheelLeft=-speed*STEP;
		break;
	case STOP:
		moveWheelLeft=0;
	}

	switch (valueWheelRight) {
	case FWD:
		moveWheelRight=speed*STEP;
		break;
	case REV:
		moveWheelRight=-speed*STEP;
		break;
	case STOP:
		moveWheelRight=0;
	}
}

void getWheels(double * values) {
	values[0]=moveWheelLeft;
	values[1]=moveWheelRight;
}

void getPositionRobot(double * position) {
	position[0]=robotX;
	position[1]=robotZ;
	position[2]=robotR;
}

void setSpeed(int speedValue) {
	speed=speedValue;
}

unsigned char getTouch1State() {
	return touch1State;
}
unsigned char getTouch3State() {
	return touch3State;
}
unsigned char getLight2State() {
	return light2State;
}

void setTouch1State(const unsigned char value) {
	touch1State=value;
}
void setTouch3State(const unsigned char value) {
	touch3State=value;
}
void setLight2State(const unsigned char value) {
	light2State=value;
}
