#ifndef ROBOT_H_
#define ROBOT_H_

//------------------------------Public types
typedef enum {
	FWD,
	REV,
	STOP
} movement;

//------------------------------Public functions
void moveRobotTo(const double x, const double z, const double r);

void moveRobotToAdd(const double x, const double z, const double r);

//Contract position must be allocated : 3 doubles vector
//position[0]=robotX, position[1]=robotZ and position[2]=robotR
void getPositionRobot(double *position);

void setWheels(const movement valueWheelLeft, const movement valueWheelRight);

//Contract valueWheelLeft and valueWheelRight must be allocated
//values[0]=moveWheelLeft and values[1]=moveWheelRight
void getWheels(double *values);

void setSpeed(const int speedValue);

unsigned char getTouch1State();
unsigned char getTouch3State();
unsigned char getLight2State();

void setTouch1State(const unsigned char value);
void setTouch3State(const unsigned char value);
void setLight2State(const unsigned char value);

#endif /*ROBOT_H_*/
