/*****************************************************************************
 * File:       PIO_bridge.c
 *
 * Description:
 *
 * External Entity: 'Actuators and Sensors'  (PIO)
 ****************************************************************************/


#include "S_enums.h"
#include "PIO_bridge.h"
#include <interfaceSimulator.h>

/*****************************************************************************
 * Bridge:  go
 ****************************************************************************/
void
PIO_go(
    const unsigned char ee_direction,
    const unsigned char ee_speed )
{
  switch ( ee_direction ) {
  case S_directiontype_backward_e:
    go(backward_direction,(int)ee_speed);
    break;
  case S_directiontype_forward_e:
    go(forward_direction,(int)ee_speed);
    break;
  case S_directiontype_go_e:
    go(go_direction,(int)ee_speed);
    break;
  case S_directiontype_left_e:
    go(left_direction,(int)ee_speed);
    break;
  case S_directiontype_right_e:
    go(right_direction,(int)ee_speed);
    break;
  case S_directiontype_stop_e:
    go(stop_direction,(int)ee_speed);
    break;
  case S_directiontype_straight_e:
    go(straight_direction,(int)ee_speed);
    break;
  default:
    go(stop_direction,(int)ee_speed);
  }
}


/*****************************************************************************
 * Bridge:  turn
 ****************************************************************************/
void
PIO_turn( const unsigned char ee_direction )
{

  switch ( ee_direction ) {
  case S_directiontype_backward_e:
    turn(backward_direction);
    break;
  case S_directiontype_forward_e:
    turn(forward_direction);
    break;
  case S_directiontype_go_e:
    turn(go_direction);
    break;
  case S_directiontype_left_e:
    turn(left_direction);
    break;
  case S_directiontype_right_e:
    turn(right_direction);
    break;
  case S_directiontype_stop_e:
    turn(stop_direction);
    break;
  case S_directiontype_straight_e:
    turn(straight_direction);
    break;
  default:
    turn(stop_direction);
  }
}


/*****************************************************************************
 * Bridge:  touch1
 ****************************************************************************/
bool
PIO_touch1()
{
  return ( touch1() );
}


/*****************************************************************************
 * Bridge:  touch3
 ****************************************************************************/
bool
PIO_touch3()
{
  return ( touch3() );
}


/*****************************************************************************
 * Bridge:  light2
 ****************************************************************************/
unsigned char
PIO_light2()
{
  return ( light2() );
}
